﻿/*----------------------------------------------
   MegaStorm Tile-based Engine - Roberto Prieto
   Copyright (C) 2007-2012 MegaStorm Systems
  ----------------------------------------------
	
	This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
    Roberto Prieto
	contact@megastormsystems.com
	http://www.megastormsystems.com

	Note that all library licenses (including the one for this library)
	are located at /licenses directory. Please, include them on your applications.

 --------------------------------------------------------------------------
		           Doxygen code for generating docs	
 -------------------------------------------------------------------------- */

/*! \mainpage MegaStorm Tile-based Engine guide
 <br>
 
 <table align="center" cellpadding="0" cellspacing="0" style="width: 700">
	 <tr>
		 <td><b>1. What's MegaStorm Tile-based Engine?</b></td>
	 </tr>
	 <tr>
		 <td>
		 <table border="0" cellpadding="2">
<tr>
<td colspan="2">\image html logotipo_mste.png</td>
</tr>
<tr>
					<td colspan="2">     &nbsp;&nbsp;&nbsp;&nbsp;     MSTE is a cross-platform engine for developing tile-based games using CRM32Pro SDK library. Although in its
origins it was created as a scroll engine, after some code revisions, it reached a higher level status than that and now
it is a powerful, stable and easy to use tile-based engine. It can be used for creating almost any kind of 2D game. 
This software is licensed under the LGPL license.</td>
				</tr>

<tr>
					<td colspan="2">Features: </td>
				</tr>

				
				<tr>
					<td colspan="2" style="height: 25px">- Level (the top level entity 
					created by 1 or more layers)</td>
				</tr>
                <tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">Orthogonal view.</td>
				</tr>
				<tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">Any number of layers. It can 
					also be modified at runtime.</td>
				</tr>
<tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">Viewport and target surface can be modified 
					at runtime.</td>
				</tr>
<tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">				
					Layers can be independent or group fixed supporting standard scroll or parallax 
					scroll.</td>
				</tr>
				<tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">Auto-scrolling capabilities.</td>
				</tr>
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="2">- Layer (contains the tile-based 
					data among other features)</td>
				</tr>
				<tr>
					<td width="30">\image html dot.gif</td>
					<td width="650">Can have any width and/or height 
					(number of cells).</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>Can have any cell size.</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>Can use any number of tilesets and each one can be of 
					any size. Larger tiles than cell size will extend at the top 
					and right.</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>Alpha value attribute ranging from 0 (full transparent) 
					to 255 (full opaque).</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>OnUpdateEnd event raised at the end of each layer 
			update.</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>OnRenderEnd event raised at the end of each layer 
			render.</td>
				</tr>
<tr>
					<td>\image html dot.gif</td>
					<td>Optional Smooth scroll rendering for getting a very 
					smooth scroll effect</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>Adding your custom maps for managing any kind of data is 
					done using C++&nbsp; inheritance class </td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>For debugging purposes, the cell limits can be rendered 
					showing the cell grid.</td>
				</tr>
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="2">- Tilesets (contains the tiles for the layers)</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>They are CRM32Pro_CTile objects. They can be stored on 
					external files or in a DPF.</td>
				</tr>
				<tr>
					<td colspan="2">&nbsp;</td>
				</tr>
				<tr>
					<td colspan="2">- I/O Formats</td>
				</tr>
				<tr>
					<td>\image html dot.gif</td>
					<td>Native XML-based file format (MSM). The MSM can be an 
					external file or stored in a DPF.</td>
				</tr>
<tr>
					<td>\image html dot.gif</td>
					<td>Import a BMP/PNG image into a layer or export a layer to 
					a BMP/PNG external image.</td>
				</tr>
<tr>
					<td>\image html dot.gif</td>
					<td>Full support for TMX files from Tiled Qt 0.81 or greater</td>
				</tr>
				
			</table>
		 </td>
	 </tr>
	 <tr>
		 <td><hr width="700"><br></td>
	 </tr>
	 <tr>
		 <td><b>2. Supported platforms</b></td>
	 </tr>
	 <tr>
		 <td>
		 <table border="0">
	<tr>
		<td>\image html multiplatform.png</td>
	</tr>
	<tr>
		<td>
		 
 	Any Windows x86 or x86-64 version. Compilers supported: <br>
&nbsp;- Visual Studio (from 6.0 to 2010)<br>
&nbsp;- GNU GCC (from 3.x to 4.x). Also, you can use mingw32/devc++.<br>
	<br>
	Any Linux x86 or x86-64 distribution. Compiler supported: <br>
&nbsp;- GNU GCC (from 3.x to 4.x).<br>
	<br>
	MacOS X 10.x x86. Compiler supported: <br>
&nbsp;- GNU GCC (4.x).</td>
	</tr>
	</table>
		
	 </tr>
	 <tr>
		 <td><hr width="700"><br></td>
	 </tr>
	 <tr>
		 <td><b>3. Change log</b></td>
	 </tr>
	 <tr>
	<td>	
		 <table border="0">
	<tr>
		<td style="height: 23px">\image html changelog.png</td>
	</tr>
	<tr>
		<td>\verbinclude History.txt</td>
	</tr>
	
	</table>
	 </tr>
	 <tr>
		 <td><hr width="700"><br></td>
	 </tr>
	 <tr>
		 <td><b>4. License</b></td>
	 </tr>
	 <tr>
		 <td>
		 <table border="0">
	<tr>
		<td>\image html osi_standard_logo.png</td>
	</tr>
	<tr>
		<td>This library is free software; you can redistribute it and/or  <br>
modify it under the terms of the GNU Lesser General Public  <br>
License as published by the Free Software Foundation; either  <br>
version 2.1 of the License, or (at your option) any later version.  <br>
  <br>
This library is distributed in the hope that it will be useful,  <br>
but WITHOUT ANY WARRANTY; without even the implied warranty of  <br>
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  <br>
Lesser General Public License for more details.  <br>
  <br>
You should have received a copy of the GNU Lesser General Public  <br>
License along with this library; if not, write to the Free Software  <br>
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA  <br>
  <br>
Author: Roberto Prieto Prieto  <br>
Email: contact@megastormsystems.com  <br>
Web page:<a href="http://www.megastormsystems.com"> http://www.megastormsystems.com</a>   <br>
  <br>Note that all library licenses (including the one for this library)  <br>
are located at /licenses directory. Please, include them on your applications.
		</td>
	</tr>
	</table>

		
	 </tr>
	 <tr>
		 <td><hr width="700"><br></td>
	 </tr>


</table>

\example Example01_Init.cpp
\image html logotipo_mste.png 

\example Example02_Import.cpp
\image html logotipo_mste.png 

\example Example03_Load.cpp
\image html logotipo_mste.png 

\example Example04_Custom.cpp
\image html logotipo_mste.png 


/** \example Example05_Tiled.cpp
* \image html logotipo_mste.png 
*/